package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class D_SumTest extends ExaminationTestDefaults {

    static private void assertByteSum(final byte expected, final byte i, byte j){
        final byte actual = D_Sum.mitigatedSum(i, j);
        if (expected != actual) {
            final String errorMessage = "Expected " + expected + " == mitigatedSum(" + i + " , " + j + ") rather than »"
                    + actual + "«. Wanna set a breakpoint for debugging?";

            // Call again to allow for debugging
            final byte actual2 = D_Sum.mitigatedSum(i, j);
            Assert.fail(errorMessage);
        }
    }

    @Marking(points = 6)
    @Test
    public void test() {
        for (byte i = Byte.MIN_VALUE; i < ++i; ) { // ... i < BYTE.MAX_VALUE; i++ loops endlessly due to byte overflow
            for (byte j = Byte.MIN_VALUE; j < ++j; ) {
                final int sum = i + j;
                if (sum < Byte.MIN_VALUE) {
                    assertByteSum(Byte.MIN_VALUE, i, j);
                } else if (sum > Byte.MAX_VALUE) {
                    assertByteSum(Byte.MAX_VALUE, i, j);
                } else {
                    assertByteSum((byte) sum, i, j);
                }
            }
        }
    }
}
